package initialization

import (
	"im-microservice/middleware"
	"im-microservice/pb"
	"im-microservice/sevice/health"
	"im-microservice/sevice/im_chat_room"
	ic "im-microservice/sevice/im_configure"
	"im-microservice/sevice/im_user"
	iur "im-microservice/sevice/im_user_relationship"

	 "github.com/grpc-ecosystem/go-grpc-middleware"
	"google.golang.org/grpc"
	"google.golang.org/grpc/reflection"
)

var RpcServer *grpc.Server

func init() {

	rpc_server := grpc.NewServer(grpc.UnaryInterceptor(grpc_middleware.ChainUnaryServer(
		middleware.Interceptor,
		middleware.Auth,
		)))
	srv := health.NewServer()
	pb.RegisterHealthServer(rpc_server, srv)
	pb.RegisterConfigureSeviceServer(rpc_server, &ic.ConfigureSevice{})
	pb.RegisterChatRoomServiceServer(rpc_server, &im_chat_room.ImChatRoomService{})
	pb.RegisterImUserServer(rpc_server, &im_user.ImUserServer{})
	pb.RegisterUserRelationshipServiceServer(rpc_server, &iur.UserRelationshipService{})
	reflection.Register(rpc_server)
	RpcServer = rpc_server
}
